C  Program to calculate approximate cementite reciprocal
C  space electron diffraction spot intensities.

      DOUBLE PRECISION FE,C,X,Y,Z,U,V,U1,V1,COEF,FETOT,
     &FEC,FES,CBTOT,CBC,CBS,AFE,AC,STR,TST1,TST2,RES,MAX,
     &TEMP
      INTEGER I,H,K,L,CNT
      DIMENSION FE(12),C(4),RES(1000)

      WRITE(6,*)
      WRITE(6,*)' ----------------------------------------------'
      WRITE(6,*)'| Calculation of Relative Electron Diffraction |'
      WRITE(6,*)'|        Spot Intensities for Cementite        |'
      WRITE(6,*)'|                                              |'
      WRITE(6,*)'|            M.Lord and H.Bhadeshia            |'
      WRITE(6,*)'|              Univ. of Cambridge              |'
      WRITE(6,*)' ----------------------------------------------'
      WRITE(6,*)


      CNT=0
      DO 10 H=0,3,1
      DO 11 K=0,3,1
      DO 12 L=0,3,1

      X=0.333D0
      Y=0.183D0
      Z=0.065D0
      U=-0.167D0
      V=0.04D0
      U1=0.47D0
      V1=-0.14D0
      AFE=2.91D0
      AC=1.15D0

      COEF=6.28318D0
      FETOT=0.0D0
      FEC=0.0D0
      FES=0.0D0
      CBTOT=0.0D0
      CBC=0.0D0
      CBS=0.0D0

C  ENTERING POSITIONS OF ATOMS INTO ARRAYS

      FE(1)=(H*X)+(K*Y)+(L*Z)
      FE(2)=(H*X)+(K*Y)+((0.5D0-Z)*L)
      FE(3)=(H*(0.5D0-X))+(K*(0.5D0+Y))+(L*Z)
      FE(4)=(H*(0.5D0-X))+(K*(0.5D0+Y))+(L*(0.5D0-Z))
      FE(5)=(H*(-X))+(K*(-Y))+(L*(-Z))
      FE(6)=(H*(-X))+(K*(-Y))+(L*(0.5D0+Z))
      FE(7)=(H*(0.5D0+X))+(K*(0.5D0-Y))+(L*(-Z))
      FE(8)=(H*(0.5D0+X))+(K*(0.5D0-Y))+(L*(0.5D0+Z))
      FE(9)=(H*U)+(K*V)+(0.25D0*L)
      FE(10)=(H*(0.5D0-U))+(K*(0.5D0+V))+(L*0.25D0)
      FE(11)=(H*U)+(K*V)+(L*0.75D0)
      FE(12)=(H*(0.5D0+U))+(K*(0.5D0-V))+(L*0.75D0)

      C(1)=(H*U1)+(K*V1)+(L*0.25D0)
      C(2)=(H*(0.5D0-U1))+(K*(0.5D0+V1))+(L*0.25D0)
      C(3)=(H*U1)+(K*V1)+(L*0.75D0)
      C(4)=(H*(0.5D0+U1))+(K*(0.5D0-V1))+(L*0.75D0)

      DO 1 I=1,12,1

      FETOT=COEF*FE(I)
      FEC=FEC+(AFE*DCOS(FETOT))
      FES=FES+(AFE*DSIN(FETOT))
      
1     CONTINUE

      DO 2 I=1,4,1

      CBTOT=COEF*C(I)
      CBC=CBC+(AC*DCOS(CBTOT))
      CBS=CBS+(AC*DSIN(CBTOT))

2     CONTINUE
      STR=0.0D0

      STR=((FEC+CBC)**2)+((FES+CBS)**2)
      TST1=(FEC**2)+(FES**2)
      TST2=(CBC**2)+(CBS**2)
      IF (CNT .GT. 0) THEN
      RES(CNT)=STR
      ENDIF

      CNT=CNT+1

C      WRITE(6,100) H,K,L,FEC,FES,CBC,CBS,STR

12    CONTINUE
11    CONTINUE
10    CONTINUE

100   FORMAT(I1,TR1,I1,TR1,I1,TR3,5F12.4)

C  SORTING OF PEAKS INTO PERCENTAGE INTENSITIES

      CNT=CNT-1
      MAX=0

      DO 101 I=1,1000
      IF (RES(I) .GT. MAX) THEN
        MAX=RES(I)
      ENDIF
101   CONTINUE

      CNTR=1
      WRITE(6,*)

      WRITE(6,*)'   H K L      INTENSITY(%)'
      WRITE(6,*)'   - - -      ------------'
      WRITE(6,*)
      DO 102 H=0,3,1
      DO 103 K=0,3,1
      DO 104 L=0,3,1
      

      IF ((H+K+L) .GT. 0) THEN
      TEMP=100.0D0*RES(CNTR)/MAX
      CNTR=CNTR+1
      WRITE(6,105) H,K,L,TEMP
      ENDIF
104   CONTINUE
103   CONTINUE
102   CONTINUE

105   FORMAT(TR4,I1,TR1,I1,TR1,I1,TR3,F12.4)

      WRITE(6,*)      

      END     
